#include <iostream>
#include <vector>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);

    int n, m;

    cin >> n >> m;

    vector<string> lavirint(n);

    for (int i = 0; i < n; i++) cin >> lavirint[i];

    vector<vector<int>> vatra(n, vector<int>(m, -1)), steva(n, vector<int>(m, -1));
    int pomerajX[] = {-1, 1, 0, 0}, pomerajY[] = {0, 0, -1, 1};
    
    vector<int> redVatrenePoljaX, redVatrenePoljaY, redStevinihPoljaX, redStevinihPoljaY;
    int brojVatrenihPolja = 0, brojStevinihPolja = 0;

    for (int i = 0; i < n; i++) 
        for (int j = 0; j < m; j++) {
            if (lavirint[i][j] == 'X') {
                vatra[i][j] = 0;
                redVatrenePoljaX.push_back(i);
                redVatrenePoljaY.push_back(j);
                brojVatrenihPolja++;
            }
            if (lavirint[i][j] == 'S') {
                steva[i][j] = 0;
                redStevinihPoljaX.push_back(i);
                redStevinihPoljaY.push_back(j);
                brojStevinihPolja++;
            }
        }

    int indeksVatrene = 0;

    while (indeksVatrene < brojVatrenihPolja) {
        int x = redVatrenePoljaX[indeksVatrene], y = redVatrenePoljaY[indeksVatrene];
        indeksVatrene++;
        for (int d = 0; d < 4; d++) {
            int nx = x + pomerajX[d], ny = y + pomerajY[d];
            if (nx >= 0 && nx < n && ny >= 0 && ny < m && lavirint[nx][ny] == '.' && vatra[nx][ny] == -1) {
                vatra[nx][ny] = vatra[x][y] + 1;
                redVatrenePoljaX.push_back(nx);
                redVatrenePoljaY.push_back(ny);
                brojVatrenihPolja++;
            }
        }
    }

    int indeksStevine = 0;

    while (indeksStevine < brojStevinihPolja) {
        int x = redStevinihPoljaX[indeksStevine], y = redStevinihPoljaY[indeksStevine];
        indeksStevine++;
        for (int d = 0; d < 4; d++) {
            int nx = x + pomerajX[d], ny = y + pomerajY[d];
            if (nx >= 0 && nx < n && ny >= 0 && ny < m && lavirint[nx][ny] == '.' && steva[nx][ny] == -1) {
                steva[nx][ny] = steva[x][y] + 1;
                redStevinihPoljaX.push_back(nx);
                redStevinihPoljaY.push_back(ny);
                brojStevinihPolja++;
            }
        }
    }

    int rezultat = 0;
    for (int i = 0; i < n; i++) 
        for (int j = 0; j < m; j++) 
            if (steva[i][j] != -1 && (vatra[i][j] == -1 || steva[i][j] < vatra[i][j])) 
                rezultat++;

    cout << rezultat;
    
    return 0;
}
//oduzeto 1h mog dragocenog zivota za ovaj zadatak(hvala Vam)